/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.pricing;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingAnticipacion;
import com.rjconsultores.ventaboletos.entidad.PricingAsiento;
import com.rjconsultores.ventaboletos.entidad.PricingCategoria;
import com.rjconsultores.ventaboletos.entidad.PricingClase;
import com.rjconsultores.ventaboletos.entidad.PricingCorrida;
import com.rjconsultores.ventaboletos.entidad.PricingDia;
import com.rjconsultores.ventaboletos.entidad.PricingImporte;
import com.rjconsultores.ventaboletos.entidad.PricingMarca;
import com.rjconsultores.ventaboletos.entidad.PricingMercado;
import com.rjconsultores.ventaboletos.entidad.PricingOcupacion;
import com.rjconsultores.ventaboletos.entidad.PricingPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.PricingRuta;
import com.rjconsultores.ventaboletos.entidad.PricingTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.PricingTipoServicio;
import com.rjconsultores.ventaboletos.entidad.PricingVigencia;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.service.PricingAnticipacionService;
import com.rjconsultores.ventaboletos.service.PricingClaseService;
import com.rjconsultores.ventaboletos.service.PricingImporteService;
import com.rjconsultores.ventaboletos.service.PricingMarcaService;
import com.rjconsultores.ventaboletos.service.PricingMercadoService;
import com.rjconsultores.ventaboletos.service.PricingPuntoVentaService;
import com.rjconsultores.ventaboletos.service.PricingRutaService;
import com.rjconsultores.ventaboletos.service.PricingService;
import com.rjconsultores.ventaboletos.service.PricingTipoPtoVtaService;
import com.rjconsultores.ventaboletos.service.PricingTipoServicioService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingAnticipacion;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingAsiento;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingCategoria;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingClase;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingCorrida;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingDia;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingImporte;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingMarca;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingMercado;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingOcupacion;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingRuta;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingTipoPtoVta;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingTipoServicio;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricingVigencia;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.logging.Level;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.List;
import java.util.Map;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("editarPricingController")
@Scope("prototype")
public class EditarPricingController extends MyGenericForwardComposer {

    @Autowired
    private PricingService pricingService;
    @Autowired
    private PricingMarcaService pricingMarcaService;
    @Autowired
    private PricingClaseService pricingClaseService;
    @Autowired
    private PricingPuntoVentaService pricingPuntoVentaService;
    @Autowired
    private PricingTipoPtoVtaService pricingTipoPtoVtaService;
    @Autowired
    private PricingRutaService pricingRutaService;
    @Autowired
    private PricingMercadoService pricingMercadoService;
    @Autowired
    private PricingImporteService pricingImporteService;
    @Autowired
    private PricingAnticipacionService pricingAnticipacionService;
    @Autowired
    private PricingTipoServicioService pricingTipoServicioService;
    @Autowired
    private EmpresaService empresaService;
    @Autowired
    private MarcaService marcaService;
    @Autowired
    private ClaseServicioService claseServicioService;
    @Autowired
    private PuntoVentaService puntoVentaService;
    @Autowired
    private TipoPuntoVentaService tipoPuntoVentaService;
    @Autowired
    private RutaService rutaService;
    @Autowired
    private ParadaService paradaService;
    private Pricing pricing;
    private MyListbox pricingList;
    private MyListbox pricingVigenciaList;
    private MyListbox pricingImporteList;
    private MyListbox pricingMarcaList;
    private MyListbox pricingClaseList;
    private MyListbox pricingPuntoVentaList;
    private MyListbox pricingTipoPtoVtaList;
    private MyListbox pricingRutaList;
    private MyListbox pricingMercadoList;
    private MyListbox pricingCategoriaList;
    private MyListbox pricingDiaList;
    private MyListbox pricingCorridaList;
    private MyListbox pricingAsientoList;
    private MyListbox pricingOcupacionList;
    private MyListbox pricingAnticipacionList;
    private MyListbox pricingTipoServicioList;
    private List<Empresa> lsEmpresa;
    private List<PricingVigencia> lsPricingVigencia;
    private List<PricingImporte> lsPricingImporte;
    private List<PricingClase> lsPricingClase;
    private List<PricingTipoPtoVta> lsPricingTipoPtoVta;
    private List<PricingPuntoVenta> lsPricingPuntoVenta;
    private List<PricingMarca> lsPricingMarca;
    private List<PricingMercado> lsPricingMercado;
    private List<PricingDia> lsPricingDia;
    private List<PricingCorrida> lsPricingCorrida;
    private List<PricingCategoria> lsPricingCategoria;
    private List<PricingAsiento> lsPricingAsiento;
    private List<PricingOcupacion> lsPricingOcupacion;
    private List<PricingRuta> lsPricingRuta;
    private List<PricingAnticipacion> lsPricingAnticipacion;
    private List<PricingTipoServicio> lsPricingTipoServicio;
    private static Logger log = Logger.getLogger(EditarPricingController.class);
    private Combobox cmbEmpresa;
    private Radio rdTransSi;
    private Radio rdTransNo;
    private Radio rdCanceSi;
    private Radio rdCanceNo;
    private Radio rdReserSi;
    private Radio rdReserNo;
    private Radio radioImp;
    private Radio radioPor;
    private MyTextboxDecimal descuentoporcredondo;
    private MyTextboxDecimal descuentoporcsen;
    private Button btnNovoImporte;
    private Button btnApagarImporte;
    private Button btnModificarImporte;
    private boolean salvo = false;
    private Boolean gravarNovo = Boolean.TRUE;
    private Button btnApagar;
    private Textbox nombrePricing;
    private Intbox itxCantboleto;
    private Intbox cantdiasanticipacion;

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa = empresaService.obtenerIndTipo1();
        lsEmpresa.add(empresaService.obtenerID(-1));

        pricing = (Pricing) Executions.getCurrent().getArg().get("pricing");
        pricingList = (MyListbox) Executions.getCurrent().getArg().get("pricingList");
        gravarNovo = (Boolean) Executions.getCurrent().getArg().get("gravarNovo");

        super.doAfterCompose(comp);

        // Vigencia
        pricingVigenciaList.setItemRenderer(new RenderPricingVigencia());
        lsPricingVigencia = new ArrayList<PricingVigencia>();
        pricingVigenciaList.setData(lsPricingVigencia);

        //Importe
        pricingImporteList.setItemRenderer(new RenderPricingImporte());
        lsPricingImporte = new ArrayList<PricingImporte>();
        pricingImporteList.setData(lsPricingImporte);

        //Marca
        pricingMarcaList.setItemRenderer(new RenderPricingMarca());
        lsPricingMarca = new ArrayList<PricingMarca>();
        pricingMarcaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingMarca pMarca = (PricingMarca) pricingMarcaList.getSelected();
                verPricingMarca(pMarca);
            }
        });

        //Clase
        pricingClaseList.setItemRenderer(new RenderPricingClase());
        lsPricingClase = new ArrayList<PricingClase>();
        pricingClaseList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingClase pClase = (PricingClase) pricingClaseList.getSelected();
                verPricingClase(pClase);
            }
        });

        //Punto Venta
        pricingPuntoVentaList.setItemRenderer(new RenderPricingPuntoVenta());
        lsPricingPuntoVenta = new ArrayList<PricingPuntoVenta>();
        pricingPuntoVentaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingPuntoVenta pPuntoVenta = (PricingPuntoVenta) pricingPuntoVentaList.getSelected();
                verPricingPuntoVenta(pPuntoVenta);
            }
        });

        //Canal Venta
        pricingTipoPtoVtaList.setItemRenderer(new RenderPricingTipoPtoVta());
        lsPricingTipoPtoVta = new ArrayList<PricingTipoPtoVta>();
        pricingTipoPtoVtaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingTipoPtoVta pTipoPtoVta = (PricingTipoPtoVta) pricingTipoPtoVtaList.getSelected();
                verPricingTipoPtoVta(pTipoPtoVta);
            }
        });

        //Rutas
        pricingRutaList.setItemRenderer(new RenderPricingRuta());
        lsPricingRuta = new ArrayList<PricingRuta>();
        pricingRutaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingRuta pRuta = (PricingRuta) pricingRutaList.getSelected();
                verPricingRuta(pRuta);
            }
        });

        //Categoria
        pricingCategoriaList.setItemRenderer(new RenderPricingCategoria());
        lsPricingCategoria = new ArrayList<PricingCategoria>();
        pricingCategoriaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingCategoria pCategoria = (PricingCategoria) pricingCategoriaList.getSelected();
                verPricingCategoria(pCategoria);
            }
        });

        //Mercado
        pricingMercadoList.setItemRenderer(new RenderPricingMercado());
        lsPricingMercado = new ArrayList<PricingMercado>();
        pricingMercadoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingMercado pMercado = (PricingMercado) pricingMercadoList.getSelected();
                verPricingMercado(pMercado);
            }
        });

        //Dia
        pricingDiaList.setItemRenderer(new RenderPricingDia());
        lsPricingDia = new ArrayList<PricingDia>();
        pricingDiaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingDia pDia = (PricingDia) pricingDiaList.getSelected();
                verPricingDia(pDia);
            }
        });

        //Corrida
        pricingCorridaList.setItemRenderer(new RenderPricingCorrida());
        lsPricingCorrida = new ArrayList<PricingCorrida>();

        //Asiento
        pricingAsientoList.setItemRenderer(new RenderPricingAsiento());
        lsPricingAsiento = new ArrayList<PricingAsiento>();
        pricingAsientoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingAsiento pAsiento = (PricingAsiento) pricingAsientoList.getSelected();
                verPricingAsiento(pAsiento);
            }
        });

        //Anticipacion
        pricingAnticipacionList.setItemRenderer(new RenderPricingAnticipacion());
        lsPricingAnticipacion = new ArrayList<PricingAnticipacion>();
        pricingAnticipacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingAnticipacion pAnticipacion = (PricingAnticipacion) pricingAnticipacionList.getSelected();
                verPricingAnticipacion(pAnticipacion);
            }
        });

        //TipoServicio
        pricingTipoServicioList.setItemRenderer(new RenderPricingTipoServicio());
        lsPricingTipoServicio = new ArrayList<PricingTipoServicio>();
        pricingTipoServicioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingTipoServicio pTipoServicio = (PricingTipoServicio) pricingTipoServicioList.getSelected();
                verPricingTipoServicio(pTipoServicio);
            }
        });

        //Ocupacion
        pricingOcupacionList.setItemRenderer(new RenderPricingOcupacion());
        lsPricingOcupacion = new ArrayList<PricingOcupacion>();
        pricingOcupacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PricingOcupacion pOcupacion = (PricingOcupacion) pricingOcupacionList.getSelected();
                verPricingOcupacion(pOcupacion);
            }
        });

        if (pricing.getPricingId() != null) {
            pricing = pricingService.obtenerID(pricing.getPricingId());

            lsPricingVigencia = pricing.getPricingVigenciaList();
            pricingVigenciaList.setData(lsPricingVigencia);
            if (lsPricingVigencia.size() > 0) {
                pricingVigenciaList.setSelectedIndex(0);
            }

            lsPricingImporte = pricing.getPricingImporteList();
            pricingImporteList.setData(lsPricingImporte);
            if (lsPricingImporte.size() > 0) {
                pricingImporteList.setSelectedIndex(0);
            }

            lsPricingMarca = pricing.getPricingMarcaList();
            pricingMarcaList.setData(lsPricingMarca);
            if (lsPricingMarca.size() > 0) {
                pricingMarcaList.setSelectedIndex(0);
            }

            lsPricingClase = pricing.getPricingClaseList();
            pricingClaseList.setData(lsPricingClase);
            if (lsPricingClase.size() > 0) {
                pricingClaseList.setSelectedIndex(0);
            }
            lsPricingAnticipacion = pricing.getPricingAnticipacionList();
            pricingAnticipacionList.setData(lsPricingAnticipacion);
            if (lsPricingAnticipacion.size() > 0) {
                pricingAnticipacionList.setSelectedIndex(0);
            }
            lsPricingTipoServicio = pricing.getPricingTipoServicioList();
            pricingTipoServicioList.setData(lsPricingTipoServicio);
            if (lsPricingTipoServicio.size() > 0) {
                pricingTipoServicioList.setSelectedIndex(0);
            }

            lsPricingPuntoVenta = pricing.getPricingPuntoventaList();
            pricingPuntoVentaList.setData(lsPricingPuntoVenta);
            if (lsPricingPuntoVenta.size() > 0) {
                pricingPuntoVentaList.setSelectedIndex(0);
            }

            lsPricingCategoria = pricing.getPricingCategoriaList();
            pricingCategoriaList.setData(lsPricingCategoria);
            if (lsPricingCategoria.size() > 0) {
                pricingCategoriaList.setSelectedIndex(0);
            }

            lsPricingRuta = pricing.getPricingRutaList();
            pricingRutaList.setData(lsPricingRuta);
            if (lsPricingRuta.size() > 0) {
                pricingRutaList.setSelectedIndex(0);
            }

            lsPricingMercado = pricing.getPricingMercadoList();
            pricingMercadoList.setData(lsPricingMercado);

            lsPricingTipoPtoVta = pricing.getPricingTipoptovtaList();
            pricingTipoPtoVtaList.setData(lsPricingTipoPtoVta);
            if (lsPricingTipoPtoVta.size() > 0) {
                pricingTipoPtoVtaList.setSelectedIndex(0);
            }

            lsPricingCorrida = pricing.getPricingCorridaList();
            pricingCorridaList.setData(lsPricingCorrida);


            lsPricingDia = pricing.getPricingDiaList();
            pricingDiaList.setData(lsPricingDia);

            lsPricingAsiento = pricing.getPricingAsientoList();
            pricingAsientoList.setData(lsPricingAsiento);

            lsPricingOcupacion = pricing.getPricingOcupacionList();
            pricingOcupacionList.setData(lsPricingOcupacion);

            lsPricingAnticipacion = pricing.getPricingAnticipacionList();
            pricingAnticipacionList.setData(lsPricingAnticipacion);
            
            lsPricingTipoServicio = pricing.getPricingTipoServicioList();
            pricingTipoServicioList.setData(lsPricingTipoServicio);

            if (pricing.getIndtransferible() == Boolean.FALSE) {
                rdTransNo.setChecked(true);
            }
            if (pricing.getIndcancelable() == Boolean.FALSE) {
                rdCanceNo.setChecked(true);
            }
            if (pricing.getIndreservable() == Boolean.FALSE) {
                rdReserNo.setChecked(true);
            }
            if (pricing.getDescuentoporcentaje() != null) {
                radioPor.setChecked(true);
            }
            if (lsPricingImporte.size() > 0) {
                radioImp.setChecked(true);
                onClick$radioImp(null);
            } else {
                radioPor.setChecked(true);
                btnNovoImporte.setVisible(false);
                btnApagarImporte.setVisible(false);
                btnModificarImporte.setVisible(false);
            }

            //BUG-1202 Não permitir alterar a empresa.
            cmbEmpresa.setDisabled(true);

            salvo = true;
        } else {
            radioPor.setChecked(true);

            btnNovoImporte.setVisible(false);
            btnApagarImporte.setVisible(false);
            btnModificarImporte.setVisible(false);
            descuentoporcredondo.setDisabled(false);

            pricingService.suscribir(pricing);
            //Marca - Preenchendo com o Objeto TODOS caso exista.
            Short id = -1;
            PricingMarca pm = new PricingMarca();
            Marca m = marcaService.obtenerID(id);
            if (m != null) {
                pm.setMarca(m);
                pm.setPricing(pricing);
                pm.setActivo(Boolean.TRUE);
                pm.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pm.setFecmodif(Calendar.getInstance().getTime());
                lsPricingMarca.add(pm);
                pricingMarcaList.setData(lsPricingMarca);
                pricingMarcaService.suscribir(pm);
            }

            //Tipo de Servicio
            PricingClase pts = new PricingClase();
            ClaseServicio cs = claseServicioService.obtenerID(id);
            if (cs != null) {
                pts.setClaseServicio(cs);
                pts.setPricing(pricing);
                pts.setActivo(Boolean.TRUE);
                pts.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pts.setFecmodif(Calendar.getInstance().getTime());
                lsPricingClase.add(pts);
                pricingClaseList.setData(lsPricingClase);
                pricingClaseService.suscribir(pts);
            }

            //Punto de Venta
            PricingPuntoVenta ppv = new PricingPuntoVenta();
            PuntoVenta pv = puntoVentaService.obtenerID(-1);
            if (pv != null) {
                ppv.setPuntoVenta(pv);
                ppv.setPricing(pricing);
                ppv.setActivo(Boolean.TRUE);
                ppv.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                ppv.setFecmodif(Calendar.getInstance().getTime());
                lsPricingPuntoVenta.add(ppv);
                pricingPuntoVentaList.setData(lsPricingPuntoVenta);
                pricingPuntoVentaService.suscribir(ppv);
            }
            //Punto de Venta
            PricingTipoPtoVta ptpv = new PricingTipoPtoVta();
            TipoPuntoVenta tpv = tipoPuntoVentaService.obtenerID((short) -1);
            if (tpv != null) {
                ptpv.setTipoPtovta(tpv);
                ptpv.setPricing(pricing);
                ptpv.setActivo(Boolean.TRUE);
                ptpv.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                ptpv.setFecmodif(Calendar.getInstance().getTime());
                lsPricingTipoPtoVta.add(ptpv);
                pricingTipoPtoVtaList.setData(lsPricingTipoPtoVta);
                pricingTipoPtoVtaService.suscribir(ptpv);
            }

            //Ruta
            PricingRuta pr = new PricingRuta();
            Ruta r = rutaService.obtenerID(-1);
            if (r != null) {
                pr.setRuta(r);
                pr.setPricing(pricing);
                pr.setActivo(Boolean.TRUE);
                pr.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pr.setFecmodif(Calendar.getInstance().getTime());
                lsPricingRuta.add(pr);
                pricingRutaList.setData(lsPricingRuta);
                pricingRutaService.suscribir(pr);
            }
            //Mercado
            PricingMercado pme = new PricingMercado();
            Parada p1 = paradaService.obtenerID(-1);
            if (p1 != null) {
                pme.setActivo(Boolean.TRUE);
                pme.setPricing(pricing);
                pme.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pme.setFecmodif(Calendar.getInstance().getTime());
                pme.setOrigen(p1);
                pme.setDestino(p1);

                lsPricingMercado.add(pme);
                pricingMercadoList.setData(lsPricingMercado);
                pricingMercadoService.suscribir(pme);
            }

            //Empresa
            Empresa emp = empresaService.obtenerID(-1);
            if (emp != null) {
                pricing.setEmpresa(emp);
                cmbEmpresa.setText(emp.getNombempresa());
            }
        }

        if (pricing.getPricingId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

    }

    public void onClick$radioImp(Event ev) {
        btnNovoImporte.setVisible(true);
        btnApagarImporte.setVisible(true);
        btnModificarImporte.setVisible(true);

        descuentoporcsen.setConstraint("");
        descuentoporcsen.setDisabled(true);
        descuentoporcsen.setValue(null);
        pricing.setDescuentoporcentaje(null);

        descuentoporcredondo.setConstraint("");
        descuentoporcredondo.setValue(null);
        descuentoporcredondo.setDisabled(true);
        pricing.setDescuentoporcredondo(null);

    }

    public void onClick$radioPor(Event ev) {
        btnNovoImporte.setVisible(false);
        btnApagarImporte.setVisible(false);
        btnModificarImporte.setVisible(false);

        //this.descuentoporcredondo.setConstraint("no empty");
        //this.descuentoporcsen.setConstraint("no empty");

        descuentoporcsen.setDisabled(false);
        descuentoporcredondo.setDisabled(false);

        Object[] listPImporte = pricingImporteList.getData();
        if (listPImporte != null) {
            for (Object o : listPImporte) {
                PricingImporte pImporte = (PricingImporte) o;
                lsPricingImporte.remove(pImporte);

                pImporte.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pImporte.setFecmodif(Calendar.getInstance().getTime());
                pImporte.setActivo(Boolean.FALSE);

                lsPricingImporte.add(pImporte);
                pricingImporteList.removeItem(pImporte);
            }

            pricingImporteList.clearSelection();
            pricing.setPricingImporteList(lsPricingImporte);
            // pricingService.actualizacion(pricing);

        }
    }

    private boolean validarNome() throws InterruptedException {
        try {
            nombrePricing.getValue();
        } catch (WrongValueException e) {

            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.nomPricingVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            return false;
        }

        return true;
    }

    private boolean validarObligatorios() throws InterruptedException {
        try {
            nombrePricing.getValue();
        } catch (WrongValueException e) {

            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.nomPricingVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            return false;
        }

        try {
            if (pricing.getEmpresa() == null) {
                Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.empresaVazio"),
                        Labels.getLabel("editarPricingController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                return false;
            }
            cmbEmpresa.getValue();
        } catch (WrongValueException e) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.empresaVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            return false;
        }

        try {
            itxCantboleto.getValue();
        } catch (WrongValueException e) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.cantAsientosCorridasVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }

        if (radioImp.isChecked()) {
            if (pricingImporteList.getModel().getSize() == 0) {
                Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.cantImportePricingVazio"),
                        Labels.getLabel("editarPricingController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
                return false;
            }
        } else {
            if ((descuentoporcsen.getValue() == null) || (descuentoporcsen.getValue().equals("")) || (descuentoporcsen.getValueDecimal().compareTo(BigDecimal.ZERO) == 0)) {
                if ((pricingAsientoList.getData().length == 0) && (pricingOcupacionList.getData().length == 0)) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.porcentajeSencilloVazio"),
                            Labels.getLabel("editarPricingController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);
                    return false;

                }
            }
        }


        if (pricingVigenciaList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.vigenciasVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }

        try {
            cantdiasanticipacion.getValue();
        } catch (WrongValueException e) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.cantDiasAntecipacionVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }

        if (pricingMarcaList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.marcaVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }
        if (pricingClaseList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.claseVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }
        if (pricingPuntoVentaList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.puntoVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }
        if (pricingRutaList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.rutaVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }
        if (pricingTipoPtoVtaList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.tipoPtoVtaVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }

        if (pricingCategoriaList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.categoriaVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }

        if (pricingMercadoList.getModel().getSize() == 0) {
            Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.mercadoVazio"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
            return false;
        }



        return true;
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        if (!validarObligatorios()) {
            return;
        }

        BigDecimal vlrdescuentoporcsen = descuentoporcsen.getValueDecimal();
        BigDecimal vlrdescuentoporcredondo = descuentoporcredondo.getValueDecimal();

        try {
            try {
                if (radioPor.isChecked()) {

                    if ((vlrdescuentoporcsen != null) && (vlrdescuentoporcsen.intValue() < -100 || vlrdescuentoporcsen.intValue() >= 1000)) {
                        Messagebox.show(
                                Labels.getLabel("editarPricingController.msgSencillo.title"),
                                Labels.getLabel("editarPricingController.window.title"),
                                Messagebox.OK, Messagebox.INFORMATION);
                        return;
                    }

                    if ((vlrdescuentoporcredondo != null) && (vlrdescuentoporcredondo.intValue() < -100 || vlrdescuentoporcredondo.intValue() >= 1000)) {
                        Messagebox.show(
                                Labels.getLabel("editarPricingController.msgRedondo.title"),
                                Labels.getLabel("editarPricingController.window.title"),
                                Messagebox.OK, Messagebox.INFORMATION);
                        return;

                    }
                }
            } catch (Exception ex) {
                log.error("PrincigController - descuentoporcsen.getValue() // descuentoporcredondo.getValue() : " + ex);
                Messagebox.show(
                        Labels.getLabel("MSG.Error"),
                        Labels.getLabel("editarPricingController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);

            }

            pricing.setEmpresa((Empresa) cmbEmpresa.getSelectedItem().getValue());

            if (rdTransSi.isChecked()) {
                pricing.setIndtransferible(Boolean.TRUE);
            } else {
                pricing.setIndtransferible(Boolean.FALSE);
            }
            if (rdCanceSi.isChecked()) {
                pricing.setIndcancelable(Boolean.TRUE);
            } else {
                pricing.setIndcancelable(Boolean.FALSE);
            }
            if (rdReserSi.isChecked()) {
                pricing.setIndreservable(Boolean.TRUE);
            } else {
                pricing.setIndreservable(Boolean.FALSE);
            }

            if (gravarNovo) {

                pricingService.actualizacion(pricing);//eu guardo antes para gantir que os dados que eu tenho na tela estão no banco
                List<Pricing> lsPricing =
                        pricingService.buscarPorNombre(pricing.getNombPricing());

                if (lsPricing.size() <= 1) {
                    pricingService.actualizacion(pricing);
                    pricingList.addItem(pricing);

                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.suscribirOK"),
                            Labels.getLabel("editarPricingController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    salvo = true;
                    //Bugzilla 1191: Não fechar janela.
                    //closeWindow();
                } else {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarPricingController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            } else {

                pricingService.actualizacion(pricing);
                pricingList.updateItem(pricing);

                Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.suscribirOK"),
                        Labels.getLabel("editarPricingController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                salvo = true;
                //Bugzilla 1191: Não fechar janela.
                //closeWindow();
            }

            //Se for por porcentage eu desativo todos os importes
            if (radioPor.isChecked()) {
                pricing = pricingService.obtenerID(pricing.getPricingId());
                for (PricingImporte pi : pricing.getPricingImporteList()) {
                    pricingImporteService.borrar(pi);
                }
            }
        } catch (Exception ex) {
            log.error("Error salvar pricing : " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);
        }

    }

    // O tratamento para deletar o Pricing (made by Monteiro) quando sair sem salvar foi mudado
    // para o evento onClose da janela.
    public void onClick$btnFechar(Event ev) {
        onClose$winEditarPricing(null);
    }

    public void onClose$winEditarPricing(Event ev) {
        if (!salvo) {
            if (pricing.getPricingId() != null) {
                pricingService.borrarFisico(pricing);
            }
        }
        closeWindow();
    }

    public void onClick$btnApagar(Event ev) throws InterruptedException {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPergunta"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                pricingService.borrar(pricing);
                Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.borrarOK"),
                        Labels.getLabel("editarPricingController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                pricingList.removeItem(pricing);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("Erro apagar pricing : " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnModificarVigencia(Event ev) {
        PricingVigencia pVigencia = (PricingVigencia) pricingVigenciaList.getSelected();

        if (pVigencia != null) {
            verPricingVigencia(pVigencia);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.windowVigencia.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarVigencia(Event ev) throws Exception {
        List<Object> listPVigencia = pricingVigenciaList.getSelectedsItens();
        if (listPVigencia != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaVigencia"),
                    Labels.getLabel("editarPricingController.windowVigencia.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                for (Object o : listPVigencia) {

                    pricing = pricingService.obtenerID(pricing.getPricingId());
                    lsPricingVigencia = pricing.getPricingVigenciaList();

                    PricingVigencia pVigencia = (PricingVigencia) o;
                    lsPricingVigencia.remove(pVigencia);

                    pVigencia.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pVigencia.setFecmodif(Calendar.getInstance().getTime());
                    pVigencia.setActivo(Boolean.FALSE);

                    lsPricingVigencia.add(pVigencia);
                    pricingVigenciaList.removeItem(pVigencia);

                    pricing.setPricingVigenciaList(lsPricingVigencia);

                    pricingService.actualizacion(pricing);
                    lsPricingVigencia.clear();
                }
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoVigencia(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingVigencia pVigencia = new PricingVigencia();
        pVigencia.setPricing(pricing);

        verPricingVigencia(pVigencia);
    }

    private void verPricingVigencia(PricingVigencia pVigencia) {
        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingVigencia", pVigencia);
        args.put("pricing", pricing);
        args.put("pricingVigenciaList", pricingVigenciaList);

        openWindow("/gui/pricing/editarPricingVigencia.zul",
                Labels.getLabel("editarPricingController.vigencia.value"), args, MODAL);
    }

    public void onClick$btnApagarImporte(Event ev) throws Exception {
        List<Object> listPImporte = pricingImporteList.getSelectedsItens();
        if (listPImporte != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaImporte"),
                    Labels.getLabel("editarPricingController.windowImporte.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                for (Object o : listPImporte) {
                    PricingImporte pImporte = (PricingImporte) o;
                    lsPricingImporte.remove(pImporte);

                    pImporte.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pImporte.setFecmodif(Calendar.getInstance().getTime());
                    pImporte.setActivo(Boolean.FALSE);

                    lsPricingImporte.add(pImporte);
                    pricingImporteList.removeItem(pImporte);
                }

                pricingImporteList.clearSelection();
                pricing.setPricingImporteList(lsPricingImporte);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.windowImporte.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoImporte(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingImporte pImporte = new PricingImporte();
        pImporte.setPricing(pricing);
        verPricingImporte(pImporte);
    }

    private void verPricingImporte(PricingImporte pImporte) {
        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingImporte", pImporte);
        args.put("pricingImporteList", pricingImporteList);

        openWindow("/gui/pricing/editarPricingImporte.zul",
                Labels.getLabel("editarPricingController.windowImporte.title"), args, MODAL);
    }

    public void onClick$btnModificarImporte(Event ev) {
        PricingImporte pImporte = (PricingImporte) pricingImporteList.getSelected();

        if (pImporte != null) {
            verPricingImporte(pImporte);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.windowImporte.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                log.error(ex);
            }
        }
    }

    public void onClick$btnApagarMarca(Event ev) throws Exception {
        List<Object> listPMarca = pricingMarcaList.getSelectedsItens();
        if (listPMarca != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaMarca"),
                    Labels.getLabel("editarPricingController.windowMarca.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                for (Object o : listPMarca) {
                    PricingMarca pMarca = (PricingMarca) o;

                    lsPricingMarca.remove(pMarca);

                    pMarca.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pMarca.setFecmodif(Calendar.getInstance().getTime());
                    pMarca.setActivo(Boolean.FALSE);

                    lsPricingMarca.add(pMarca);
                    pricingMarcaList.removeItem(pMarca);
                    pricingMarcaList.clearSelection();

                    pricing.setPricingMarcaList(lsPricingMarca);
                    pricingService.actualizacion(pricing);
                }
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoMarca(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingMarca pMarca = new PricingMarca();
        pMarca.setPricing(pricing);
        verPricingMarca(pMarca);
    }

    private void verPricingMarca(PricingMarca pMarca) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingMarca", pMarca);
        args.put("pricingMarcaList", pricingMarcaList);

        openWindow("/gui/pricing/editarPricingMarca.zul",
                Labels.getLabel("editarPricingController.windowMarca.title"), args, MODAL);
    }

    public void onClick$btnModificarMarca(Event ev) {

        PricingMarca pMarca = (PricingMarca) pricingMarcaList.getSelected();

        if (pMarca != null) {
            verPricingMarca(pMarca);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarClase(Event ev) throws Exception {
        List<Object> listPClase = pricingClaseList.getSelectedsItens();

        if (listPClase != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaClase"),
                    Labels.getLabel("editarPricingController.windowClase.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                for (Object o : listPClase) {

                    PricingClase pClase = (PricingClase) o;

                    lsPricingClase.remove(pClase);

                    pClase.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pClase.setFecmodif(Calendar.getInstance().getTime());
                    pClase.setActivo(Boolean.FALSE);

                    lsPricingClase.add(pClase);
                    pricingClaseList.removeItem(pClase);
                    pricingClaseList.clearSelection();

                    pricing.setPricingClaseList(lsPricingClase);
                    pricingService.actualizacion(pricing);
                }
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoClase(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingClase pClase = new PricingClase();
        pClase.setPricing(pricing);
        verPricingClase(pClase);
    }

    private void verPricingClase(PricingClase pClase) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingClase", pClase);
        args.put("pricingClaseList", pricingClaseList);

        openWindow("/gui/pricing/editarPricingClase.zul",
                Labels.getLabel("editarPricingController.windowTipoServicio.title"), args, MODAL);
    }

    public void onClick$btnModificarClase(Event ev) {

        PricingClase pClase = (PricingClase) pricingClaseList.getSelected();

        if (pClase != null) {
            verPricingClase(pClase);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarPuntoVenta(Event ev) throws Exception {
        List<Object> listPuntoVenta = pricingPuntoVentaList.getSelectedsItens();
        if (listPuntoVenta != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaPuntoVenta"),
                    Labels.getLabel("editarPricingController.windowPuntoVenta.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {

                for (Object o : listPuntoVenta) {

                    PricingPuntoVenta pPuntoVenta = (PricingPuntoVenta) o;
                    lsPricingPuntoVenta.remove(pPuntoVenta);

                    pPuntoVenta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pPuntoVenta.setFecmodif(Calendar.getInstance().getTime());
                    pPuntoVenta.setActivo(Boolean.FALSE);

                    lsPricingPuntoVenta.add(pPuntoVenta);
                    pricingPuntoVentaList.removeItem(pPuntoVenta);
                    pricingPuntoVentaList.clearSelection();

                    pricing.setPricingPuntoventaList(lsPricingPuntoVenta);
                    pricingService.actualizacion(pricing);
                }
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoPuntoVenta(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingPuntoVenta pPuntoVenta = new PricingPuntoVenta();
        pPuntoVenta.setPricing(pricing);
        verPricingPuntoVenta(pPuntoVenta);
    }

    private void verPricingPuntoVenta(PricingPuntoVenta pPuntoVenta) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingPuntoVenta", pPuntoVenta);
        args.put("pricingPuntoVentaList", pricingPuntoVentaList);

        openWindow("/gui/pricing/editarPricingPuntoVenta.zul",
                Labels.getLabel("editarPricingController.windowPuntoVenta.title"), args, MODAL);
    }

    public void onClick$btnModificarPuntoVenta(Event ev) {

        PricingPuntoVenta pPuntoVenta = (PricingPuntoVenta) pricingPuntoVentaList.getSelected();

        if (pPuntoVenta != null) {
            verPricingPuntoVenta(pPuntoVenta);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarTipoPtoVta(Event ev) throws Exception {
        List<Object> listTipoPtoVta = pricingTipoPtoVtaList.getSelectedsItens();
        if (listTipoPtoVta != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaTipoPtoVta"),
                    Labels.getLabel("editarPricingController.windowTipoPtoVta.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                for (Object r : listTipoPtoVta) {
                    PricingTipoPtoVta pTipoPtoVta = (PricingTipoPtoVta) r;

                    lsPricingTipoPtoVta.remove(pTipoPtoVta);
                    pTipoPtoVta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pTipoPtoVta.setFecmodif(Calendar.getInstance().getTime());
                    pTipoPtoVta.setActivo(Boolean.FALSE);

                    lsPricingTipoPtoVta.add(pTipoPtoVta);
                    pricingTipoPtoVtaList.removeItem(pTipoPtoVta);
                    pricingTipoPtoVtaList.clearSelection();

                    pricing.setPricingTipoptovtaList(lsPricingTipoPtoVta);
                    pricingService.actualizacion(pricing);
                }
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoTipoPtoVta(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingTipoPtoVta pTipoPtoVta = new PricingTipoPtoVta();
        pTipoPtoVta.setPricing(pricing);
        verPricingTipoPtoVta(pTipoPtoVta);
    }

    private void verPricingTipoPtoVta(PricingTipoPtoVta pTipoPtoVta) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingTipoPtoVta", pTipoPtoVta);
        args.put("pricingTipoPtoVtaList", pricingTipoPtoVtaList);

        openWindow("/gui/pricing/editarPricingTipoPtoVta.zul",
                Labels.getLabel("editarPricingController.windowTipoPtoVta.title"), args, MODAL);
    }

    public void onClick$btnModificarTipoPtoVta(Event ev) {

        PricingTipoPtoVta pTipoPtoVta = (PricingTipoPtoVta) pricingTipoPtoVtaList.getSelected();

        if (pTipoPtoVta != null) {
            verPricingTipoPtoVta(pTipoPtoVta);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarCategoria(Event ev) throws Exception {
        List<Object> listPCategoria = pricingCategoriaList.getSelectedsItens();
        if (listPCategoria != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaCategoria"),
                    Labels.getLabel("editarPricingController.windowCategoria.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                for (Object o : listPCategoria) {
                    PricingCategoria pCategoria = (PricingCategoria) o;
                    lsPricingCategoria.remove(pCategoria);

                    pCategoria.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pCategoria.setFecmodif(Calendar.getInstance().getTime());
                    pCategoria.setActivo(Boolean.FALSE);

                    lsPricingCategoria.add(pCategoria);
                    pricingCategoriaList.removeItem(pCategoria);
                    pricingCategoriaList.clearSelection();

                    pricing.setPricingCategoriaList(lsPricingCategoria);
                    pricingService.actualizacion(pricing);
                }
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoCategoria(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingCategoria pCategoria = new PricingCategoria();
        pCategoria.setPricing(pricing);
        verPricingCategoria(pCategoria);
    }

    private void verPricingCategoria(PricingCategoria pCategoria) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingCategoria", pCategoria);
        args.put("pricingCategoriaList", pricingCategoriaList);

        openWindow("/gui/pricing/editarPricingCategoria.zul",
                Labels.getLabel("editarPricingController.windowCategoria.title"), args, MODAL);
    }

    public void onClick$btnModificarCategoria(Event ev) {

        PricingCategoria pCategoria = (PricingCategoria) pricingCategoriaList.getSelected();

        if (pCategoria != null) {
            verPricingCategoria(pCategoria);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarRuta(Event ev) throws Exception {

        List<Object> listRuta = pricingRutaList.getSelectedsItens();
        if (listRuta != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaRuta"),
                    Labels.getLabel("editarPricingController.windowRuta.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                for (Object r : listRuta) {
                    PricingRuta pRuta = (PricingRuta) r;

                    lsPricingRuta.remove(pRuta);

                    pRuta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    pRuta.setFecmodif(Calendar.getInstance().getTime());
                    pRuta.setActivo(Boolean.FALSE);

                    lsPricingRuta.add(pRuta);
                    pricingRutaList.removeItem(pRuta);


                }
                pricingRutaList.clearSelection();
                pricing.setPricingRutaList(lsPricingRuta);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoRuta(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingRuta pRuta = new PricingRuta();
        pRuta.setPricing(pricing);
        verPricingRuta(pRuta);
    }

    private void verPricingRuta(PricingRuta pRuta) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingRuta", pRuta);
        args.put("pricingRutaList", pricingRutaList);

        openWindow("/gui/pricing/editarPricingRuta.zul",
                Labels.getLabel("editarPricingController.windowRuta.title"), args, MODAL);
    }

    public void onClick$btnModificarRuta(Event ev) {

        PricingRuta pRuta = (PricingRuta) pricingRutaList.getSelected();

        if (pRuta != null) {
            verPricingRuta(pRuta);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarMercado(Event ev) throws Exception {
        PricingMercado pMercado = (PricingMercado) pricingMercadoList.getSelected();
        if (pMercado != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaMercado"),
                    Labels.getLabel("editarPricingController.windowMercado.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                lsPricingMercado.remove(pMercado);

                pMercado.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pMercado.setFecmodif(Calendar.getInstance().getTime());
                pMercado.setActivo(Boolean.FALSE);

                lsPricingMercado.add(pMercado);
                pricingMercadoList.removeItem(pMercado);
                pricingMercadoList.clearSelection();

                pricing.setPricingMercadoList(lsPricingMercado);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoMercado(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingMercado pMercado = new PricingMercado();
        pMercado.setPricing(pricing);

        verPricingMercado(pMercado);
    }

    private void verPricingMercado(PricingMercado pMercado) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingMercado", pMercado);
        args.put("pricingMercadoList", pricingMercadoList);

        openWindowPosi("/gui/pricing/editarPricingMercado.zul",
                Labels.getLabel("editarPricingController.windowMercado.title"), args, MODAL, "center,top");
    }

    public void onClick$btnModificarMercado(Event ev) {

        PricingMercado pMercado = (PricingMercado) pricingMercadoList.getSelected();

        if (pMercado != null) {
            verPricingMercado(pMercado);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarCorrida(Event ev) throws Exception {
        PricingCorrida pCorrida = (PricingCorrida) pricingCorridaList.getSelected();
        if (pCorrida != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaCorrida"),
                    Labels.getLabel("editarPricingController.windowCorrida.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                pCorrida.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pCorrida.setFecmodif(Calendar.getInstance().getTime());
                pCorrida.setActivo(Boolean.FALSE);

                pricing.setPricingCorridaList(lsPricingCorrida);
                pricingService.actualizacion(pricing);

                lsPricingCorrida.remove(pCorrida);
                pricingCorridaList.removeItem(pCorrida);
                pricingCorridaList.clearSelection();
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"),
                    Labels.getLabel("editarPricingController.window.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoCorrida(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }

        verPricingCorrida();
    }

    private void verPricingCorrida() {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricing", pricing);
        args.put("pricingCorridaList", pricingCorridaList);

        openWindow("/gui/pricing/editarPricingCorrida.zul",
                Labels.getLabel("editarPricingController.windowCorrida.title"), args, MODAL);
    }

    public void onClick$btnModificarCorrida(Event ev) {

        PricingCorrida pCorrida = (PricingCorrida) pricingCorridaList.getSelected();

        if (pCorrida != null) {
            verPricingCorrida();
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"),
                        Labels.getLabel("editarPricingController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarDia(Event ev) throws Exception {
        PricingDia pDia = (PricingDia) pricingDiaList.getSelected();
        if (pDia != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaDia"),
                    Labels.getLabel("editarPricingController.windowDia.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                lsPricingDia.remove(pDia);

                pDia.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pDia.setFecmodif(Calendar.getInstance().getTime());
                pDia.setActivo(Boolean.FALSE);

                lsPricingDia.add(pDia);
                pricingDiaList.removeItem(pDia);
                pricingDiaList.clearSelection();

                pricing.setPricingDiaList(lsPricingDia);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoDia(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingDia pDia = new PricingDia();
        pDia.setPricing(pricing);
        verPricingDia(pDia);
    }

    private void verPricingDia(PricingDia pDia) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingDia", pDia);
        args.put("pricingDiaList", pricingDiaList);

        openWindow("/gui/pricing/editarPricingDia.zul",
                Labels.getLabel("editarPricingController.windowDia.title"), args, MODAL);
    }

    public void onClick$btnModificarDia(Event ev) {

        PricingDia pDia = (PricingDia) pricingDiaList.getSelected();

        if (pDia != null) {
            verPricingDia(pDia);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarOcupacion(Event ev) throws Exception {
        PricingOcupacion pOcupacion = (PricingOcupacion) pricingOcupacionList.getSelected();
        if (pOcupacion != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaOcupacion"),
                    Labels.getLabel("editarPricingController.windowOcupacion.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                lsPricingOcupacion.remove(pOcupacion);

                pOcupacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pOcupacion.setFecmodif(Calendar.getInstance().getTime());
                pOcupacion.setActivo(Boolean.FALSE);

                lsPricingOcupacion.add(pOcupacion);
                pricingOcupacionList.removeItem(pOcupacion);
                pricingOcupacionList.clearSelection();

                pricing.setPricingOcupacionList(lsPricingOcupacion);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoOcupacion(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingOcupacion pOcupacion = new PricingOcupacion();
        pOcupacion.setPricing(pricing);
        verPricingOcupacion(pOcupacion);
    }

    private void verPricingOcupacion(PricingOcupacion pOcupacion) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingOcupacion", pOcupacion);
        args.put("pricing", pricing);
        args.put("pricingOcupacionList", pricingOcupacionList);

        openWindow("/gui/pricing/editarPricingOcupacion.zul",
                Labels.getLabel("editarPricingController.windowOcupacion.title"), args, MODAL);
    }

    public void onClick$btnModificarOcupacion(Event ev) {

        PricingOcupacion pOcupacion = (PricingOcupacion) pricingOcupacionList.getSelected();

        if (pOcupacion != null) {
            verPricingOcupacion(pOcupacion);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarAsiento(Event ev) throws Exception {
        PricingAsiento pAsiento = (PricingAsiento) pricingAsientoList.getSelected();
        if (pAsiento != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaAsiento"),
                    Labels.getLabel("editarPricingController.windowAsiento.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                lsPricingAsiento.remove(pAsiento);

                pAsiento.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pAsiento.setFecmodif(Calendar.getInstance().getTime());
                pAsiento.setActivo(Boolean.FALSE);

                lsPricingAsiento.add(pAsiento);
                pricingAsientoList.removeItem(pAsiento);
                pricingAsientoList.clearSelection();

                pricing.setPricingAsientoList(lsPricingAsiento);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoAsiento(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingAsiento pAsiento = new PricingAsiento();
        pAsiento.setPricing(pricing);
        verPricingAsiento(pAsiento);
    }

    private void verPricingAsiento(PricingAsiento pAsiento) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingAsiento", pAsiento);
        args.put("pricingAsientoList", pricingAsientoList);

        openWindow("/gui/pricing/editarPricingAsiento.zul",
                Labels.getLabel("editarPricingController.windowAsiento.title"), args, MODAL);
    }

    public void onClick$btnModificarAsiento(Event ev) {

        PricingAsiento pAsiento = (PricingAsiento) pricingAsientoList.getSelected();

        if (pAsiento != null) {
            verPricingAsiento(pAsiento);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarAnticipacion(Event ev) throws Exception {
        PricingAnticipacion pAnticipacion = (PricingAnticipacion) pricingAnticipacionList.getSelected();
        if (pAnticipacion != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaAnticipacion"),
                    Labels.getLabel("editarPricingController.windowAnticipacion.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                lsPricingAnticipacion.remove(pAnticipacion);

                pAnticipacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pAnticipacion.setFecmodif(Calendar.getInstance().getTime());
                pAnticipacion.setActivo(Boolean.FALSE);

                lsPricingAnticipacion.add(pAnticipacion);
                pricingAnticipacionList.removeItem(pAnticipacion);
                pricingAnticipacionList.clearSelection();

                pricing.setPricingAnticipacionList(lsPricingAnticipacion);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoAnticipacion(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingAnticipacion pAnticipacion = new PricingAnticipacion();
        pAnticipacion.setPricing(pricing);
        verPricingAnticipacion(pAnticipacion);
    }

    private void verPricingAnticipacion(PricingAnticipacion pAnticipacion) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingAnticipacion", pAnticipacion);
        args.put("pricingAnticipacionList", pricingAnticipacionList);

        openWindow("/gui/pricing/editarPricingAnticipacion.zul",
                Labels.getLabel("editarPricingController.windowAnticipacion.title"), args, MODAL);
    }

    public void onClick$btnModificarAnticipacion(Event ev) {

        PricingAnticipacion pAnticipacion = (PricingAnticipacion) pricingAnticipacionList.getSelected();

        if (pAnticipacion != null) {
            verPricingAnticipacion(pAnticipacion);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void onClick$btnApagarTipoServicio(Event ev) throws Exception {
        PricingTipoServicio pTipoServicio = (PricingTipoServicio) pricingTipoServicioList.getSelected();
        if (pTipoServicio != null) {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPricingController.MSG.borrarPerguntaTipoServicio"),
                    Labels.getLabel("editarPricingController.windowTipoServicio.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);
            if (resp == Messagebox.YES) {
                lsPricingTipoServicio.remove(pTipoServicio);

                pTipoServicio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                pTipoServicio.setFecmodif(Calendar.getInstance().getTime());
                pTipoServicio.setActivo(Boolean.FALSE);

                lsPricingTipoServicio.add(pTipoServicio);
                pricingTipoServicioList.removeItem(pTipoServicio);
                pricingTipoServicioList.clearSelection();

                pricing.setPricingTipoServicioList(lsPricingTipoServicio);
                pricingService.actualizacion(pricing);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnNovoTipoServicio(Event ev) throws InterruptedException {
        if (!validarNome()) {
            return;
        }
        PricingTipoServicio pTipoServicio = new PricingTipoServicio();
        pTipoServicio.setPricing(pricing);
        verPricingTipoServicio(pTipoServicio);
    }

    private void verPricingTipoServicio(PricingTipoServicio pTipoServicio) {

        if (pricing.getPricingId() == null) {
            pricingService.suscribir(pricing);
        }

        Map args = new HashMap();
        args.put("pricingTipoServicio", pTipoServicio);
        args.put("pricingTipoServicioList", pricingTipoServicioList);

        openWindow("/gui/pricing/editarPricingTipoServicio.zul",
                Labels.getLabel("editarPricingController.windowTipoServicio.title"), args, MODAL);
    }

    public void onClick$btnModificarTipoServicio(Event ev) {

        PricingTipoServicio pTipoServicio = (PricingTipoServicio) pricingTipoServicioList.getSelected();

        if (pTipoServicio != null) {
            verPricingTipoServicio(pTipoServicio);
        } else {
            try {
                Messagebox.show(Labels.getLabel("editarPricingController.MSG.selectItem"), Labels.getLabel("editarPricingController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            } catch (InterruptedException ex) {
                java.util.logging.Logger.getLogger(EditarPricingController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }

    public Pricing getPricing() {
        return pricing;
    }

    public void setPricing(Pricing pricing) {
        this.pricing = pricing;
    }

    public MyListbox getPricingList() {
        return pricingList;
    }

    public void setPricingList(MyListbox pricingList) {
        this.pricingList = pricingList;
    }

    public PricingService getPricingService() {
        return pricingService;
    }

    public void setPricingService(PricingService pricingService) {
        this.pricingService = pricingService;
    }

    public List<PricingVigencia> getLsPricingVigencia() {
        return lsPricingVigencia;
    }

    public void setLsPricingVigencia(List<PricingVigencia> lsPricingVigencia) {
        this.lsPricingVigencia = lsPricingVigencia;
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public void setCmbEmpresa(Combobox cmbEmpresa) {
        this.cmbEmpresa = cmbEmpresa;
    }

    public List<PricingAsiento> getLsPricingAsiento() {
        return lsPricingAsiento;
    }

    public void setLsPricingAsiento(List<PricingAsiento> lsPricingAsiento) {
        this.lsPricingAsiento = lsPricingAsiento;
    }

    public List<PricingCategoria> getLsPricingCategoria() {
        return lsPricingCategoria;
    }

    public void setLsPricingCategoria(List<PricingCategoria> lsPricingCategoria) {
        this.lsPricingCategoria = lsPricingCategoria;
    }

    public List<PricingClase> getLsPricingClase() {
        return lsPricingClase;
    }

    public void setLsPricingClase(List<PricingClase> lsPricingClase) {
        this.lsPricingClase = lsPricingClase;
    }

    public List<PricingDia> getLsPricingDia() {
        return lsPricingDia;
    }

    public void setLsPricingDia(List<PricingDia> lsPricingDia) {
        this.lsPricingDia = lsPricingDia;
    }

    public List<PricingImporte> getLsPricingImporte() {
        return lsPricingImporte;
    }

    public void setLsPricingImporte(List<PricingImporte> lsPricingImporte) {
        this.lsPricingImporte = lsPricingImporte;
    }

    public List<PricingMarca> getLsPricingMarca() {
        return lsPricingMarca;
    }

    public void setLsPricingMarca(List<PricingMarca> lsPricingMarca) {
        this.lsPricingMarca = lsPricingMarca;
    }

    public List<PricingMercado> getLsPricingMercado() {
        return lsPricingMercado;
    }

    public void setLsPricingMercado(List<PricingMercado> lsPricingMercado) {
        this.lsPricingMercado = lsPricingMercado;
    }

    public List<PricingOcupacion> getLsPricingOcupacion() {
        return lsPricingOcupacion;
    }

    public void setLsPricingOcupacion(List<PricingOcupacion> lsPricingOcupacion) {
        this.lsPricingOcupacion = lsPricingOcupacion;
    }

    public List<PricingRuta> getLsPricingRuta() {
        return lsPricingRuta;
    }

    public void setLsPricingRuta(List<PricingRuta> lsPricingRuta) {
        this.lsPricingRuta = lsPricingRuta;
    }

    public MyListbox getPricingImporteList() {
        return pricingImporteList;
    }

    public void setPricingImporteList(MyListbox pricingImporteList) {
        this.pricingImporteList = pricingImporteList;
    }

    public MyListbox getPricingVigenciaList() {
        return pricingVigenciaList;
    }

    public void setPricingVigenciaList(MyListbox pricingVigenciaList) {
        this.pricingVigenciaList = pricingVigenciaList;
    }

    public Radio getRdCanceNo() {
        return rdCanceNo;
    }

    public void setRdCanceNo(Radio rdCanceNo) {
        this.rdCanceNo = rdCanceNo;
    }

    public Radio getRdCanceSi() {
        return rdCanceSi;
    }

    public void setRdCanceSi(Radio rdCanceSi) {
        this.rdCanceSi = rdCanceSi;
    }

    public Radio getRdReserNo() {
        return rdReserNo;
    }

    public void setRdReserNo(Radio rdReserNo) {
        this.rdReserNo = rdReserNo;
    }

    public Radio getRdReserSi() {
        return rdReserSi;
    }

    public void setRdReserSi(Radio rdReserSi) {
        this.rdReserSi = rdReserSi;
    }

    public Radio getRdTransNo() {
        return rdTransNo;
    }

    public void setRdTransNo(Radio rdTransNo) {
        this.rdTransNo = rdTransNo;
    }

    public Radio getRdTransSi() {
        return rdTransSi;
    }

    public void setRdTransSi(Radio rdTransSi) {
        this.rdTransSi = rdTransSi;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Button getBtnApagarImporte() {
        return btnApagarImporte;
    }

    public void setBtnApagarImporte(Button btnApagarImporte) {
        this.btnApagarImporte = btnApagarImporte;
    }

    public Button getBtnModificarImporte() {
        return btnModificarImporte;
    }

    public void setBtnModificarImporte(Button btnModificarImporte) {
        this.btnModificarImporte = btnModificarImporte;
    }

    public Button getBtnNovoImporte() {
        return btnNovoImporte;
    }

    public void setBtnNovoImporte(Button btnNovoImporte) {
        this.btnNovoImporte = btnNovoImporte;
    }

    public Radio getRadioImp() {
        return radioImp;
    }

    public void setRadioImp(Radio radioImp) {
        this.radioImp = radioImp;
    }

    public Radio getRadioPor() {
        return radioPor;
    }

    public void setRadioPor(Radio radioPor) {
        this.radioPor = radioPor;
    }
}
