/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Empleado;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Perfil;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.entidad.UsuarioPerfil;
import com.rjconsultores.ventaboletos.entidad.UsuarioUbicacion;
import com.rjconsultores.ventaboletos.service.EmpleadoService;
import com.rjconsultores.ventaboletos.service.PerfilService;
import com.rjconsultores.ventaboletos.service.UsuarioPerfilService;
import com.rjconsultores.ventaboletos.service.UsuarioService;
import com.rjconsultores.ventaboletos.service.UsuarioUbicacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.Base64;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderUbicacion;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Tab;
import org.zkoss.zul.Textbox;

/**
 *
 * @author rodrigo
 */
@Controller("editarUsuarioController")
@Scope("prototype")
public class EditarUsuarioController extends MyGenericForwardComposer {

    @Autowired
    private UsuarioService usuarioService;
    @Autowired
    private PerfilService perfilService;
    @Autowired
    private UsuarioPerfilService usuarioPerfilService;
    @Autowired
    private UsuarioUbicacionService usuarioUbicacionService;
    @Autowired
    private EmpleadoService empleadoService;
    private List<Perfil> lsPerfil;
    private Perfil perfilSeleccionada;
    private List<UsuarioUbicacion> lsUsuarioUbicacion;
    private Combobox cmbParada;
    private Combobox cmbPuntoVenta;
    private Combobox cmbPerfil;
    private Usuario usuario;
    private MyListbox usuarioList;
    private MyListbox ubicacionList;
    private Textbox txtCveEmpleado;
    private Textbox txtNombUsuario;
    private Textbox txtSenha;
    private Textbox txtConfirmSenha;
    private Textbox txtCveUsuario;
    private Textbox txtNombPaterno;
    private Textbox txtNombMaterno;
    private Button btnAdicionarUbicacion;
    private Button btnRemoverUbicacion;
    private Button btnApagar;
    private Button btnPesquisa;
    private Boolean usrAdmin;
    private Tab tabUsuario;
    private Tab tabUbicacion;
    private static Logger log = Logger.getLogger(EditarUsuarioController.class);

    public MyListbox getUbicacionList() {
        return ubicacionList;
    }

    public void setUbicacionList(MyListbox ubicacionList) {
        this.ubicacionList = ubicacionList;
    }

    public Combobox getCmbParada() {
        return cmbParada;
    }

    public void setCmbParada(Combobox cmbParada) {
        this.cmbParada = cmbParada;
    }

    public Combobox getCmbPuntoVenta() {
        return cmbPuntoVenta;
    }

    public void setCmbPuntoVenta(Combobox cmbPuntoVenta) {
        this.cmbPuntoVenta = cmbPuntoVenta;
    }

    public Textbox getTxtConfirmSenha() {
        return txtConfirmSenha;
    }

    public void setTxtConfirmSenha(Textbox txtConfirmSenha) {
        this.txtConfirmSenha = txtConfirmSenha;
    }

    public Textbox getTxtSenha() {
        return txtSenha;
    }

    public void setTxtSenha(Textbox txtSenha) {
        this.txtSenha = txtSenha;
    }

    public List<Perfil> getLsPerfil() {
        return lsPerfil;
    }

    public void setLsPerfil(List<Perfil> lsPerfil) {
        this.lsPerfil = lsPerfil;
    }

    public Textbox getTxtNombUsuario() {
        return txtNombUsuario;
    }

    public void setTxtNombUsuario(Textbox txtNombUsuario) {
        this.txtNombUsuario = txtNombUsuario;
    }

    public Usuario getUsuario() {
        return usuario;
    }

    public void setUsuario(Usuario usuario) {
        this.usuario = usuario;
    }

    public Button getBtnAdicionarUbicacion() {
        return btnAdicionarUbicacion;
    }

    public void setBtnAdicionarUbicacion(Button btnAdicionarUbicacion) {
        this.btnAdicionarUbicacion = btnAdicionarUbicacion;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Combobox getCmbPerfil() {
        return cmbPerfil;
    }

    public void setCmbPerfil(Combobox cmbPerfil) {
        this.cmbPerfil = cmbPerfil;
    }

    public List<UsuarioUbicacion> getLsUsuarioUbicacion() {
        return lsUsuarioUbicacion;
    }

    public void setLsUsuarioUbicacion(List<UsuarioUbicacion> lsUsuarioUbicacion) {
        this.lsUsuarioUbicacion = lsUsuarioUbicacion;
    }

    public Textbox getTxtCveUsuario() {
        return txtCveUsuario;
    }

    public void setTxtCveUsuario(Textbox txtCveUsuario) {
        this.txtCveUsuario = txtCveUsuario;
    }

    public Button getBtnRemoverUbicacion() {
        return btnRemoverUbicacion;
    }

    public void setBtnRemoverUbicacion(Button btnRemoverUbicacion) {
        this.btnRemoverUbicacion = btnRemoverUbicacion;
    }

    public PerfilService getPerfilService() {
        return perfilService;
    }

    public void setPerfilService(PerfilService perfilService) {
        this.perfilService = perfilService;
    }

    public Textbox getTxtNombMaterno() {
        return txtNombMaterno;
    }

    public void setTxtNombMaterno(Textbox txtNombMaterno) {
        this.txtNombMaterno = txtNombMaterno;
    }

    public Textbox getTxtNombPaterno() {
        return txtNombPaterno;
    }

    public void setTxtNombPaterno(Textbox txtNombPaterno) {
        this.txtNombPaterno = txtNombPaterno;
    }

    public Textbox getTxtCveEmpleado() {
        return txtCveEmpleado;
    }

    public void setTxtCveEmpleado(Textbox txtCveEmpleado) {
        this.txtCveEmpleado = txtCveEmpleado;
    }

    public Button getBtnPesquisa() {
        return btnPesquisa;
    }

    public void setBtnPesquisa(Button btnPesquisa) {
        this.btnPesquisa = btnPesquisa;
    }

    public Tab getTabUsuario() {
        return tabUsuario;
    }

    public void setTabUsuario(Tab tabUsuario) {
        this.tabUsuario = tabUsuario;
    }

    public Tab getTabUbicacion() {
        return tabUbicacion;
    }

    public void setTabUbicacion(Tab tabUbicacion) {
        this.tabUbicacion = tabUbicacion;
    }

    public Perfil getPerfilSeleccionada() {
        return perfilSeleccionada;
    }

    public void setPerfilSeleccionada(Perfil perfilSeleccionada) {
        this.perfilSeleccionada = perfilSeleccionada;
    }

    private void enableAddUbicacion() {
        if (lsUsuarioUbicacion.size() > 0) {
            btnAdicionarUbicacion.setDisabled(true);
        } else {
            btnAdicionarUbicacion.setDisabled(false);
        }
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsPerfil = perfilService.obtenerTodos();

        super.doAfterCompose(comp);

        Usuario usuarioS = (Usuario) Executions.getCurrent().getArg().get("usuario");
        usuario = (usuarioS.getUsuarioId() == null) ? usuarioS : usuarioService.obtenerID(usuarioS.getUsuarioId());
        usuarioList = (MyListbox) Executions.getCurrent().getArg().get("usuarioList");
        usrAdmin = (Boolean) Executions.getCurrent().getArg().get("usrAdmin");

        lsUsuarioUbicacion = new ArrayList<UsuarioUbicacion>();
        if (usuario.getUsuarioId() != null) {
            lsUsuarioUbicacion.addAll(usuarioUbicacionService.buscarPorUsuario(usuario));
        }

        enableAddUbicacion();

        ubicacionList.setItemRenderer(new RenderUbicacion());
        ubicacionList.setData(lsUsuarioUbicacion);

        txtCveEmpleado.focus();

        if (usuario.getUsuarioId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            txtCveUsuario.setDisabled(Boolean.TRUE);
            if (usuario.getEmpleado() != null) {
                usuario = usuarioService.obtenerID(usuario.getUsuarioId());
                cmbPerfil.focus();
                txtCveEmpleado.setText(usuario.getEmpleado().getCveEmpleado());
                txtCveEmpleado.setDisabled(true);
                txtNombUsuario.setDisabled(true);
                txtNombPaterno.setDisabled(true);
                txtNombMaterno.setDisabled(true);
                btnPesquisa.setVisible(false);


            }
            List<UsuarioPerfil> lsUsuarioPerfil = usuarioPerfilService.obtenerPorUsuario(usuario);
            if (!lsUsuarioPerfil.isEmpty()) {
                perfilSeleccionada = lsUsuarioPerfil.get(0).getPerfil();
            }

            txtSenha.setText("**********");
            txtConfirmSenha.setText("**********");
        }

        if (!usrAdmin) {
            cmbPerfil.setDisabled(Boolean.TRUE);
            txtCveUsuario.setDisabled(Boolean.TRUE);
            btnApagar.setVisible(Boolean.FALSE);

            btnAdicionarUbicacion.setVisible(Boolean.FALSE);
            btnRemoverUbicacion.setVisible(Boolean.FALSE);
            cmbParada.setDisabled(Boolean.TRUE);
            cmbPuntoVenta.setDisabled(Boolean.TRUE);
        }


    }

    public void onFocus$txtSenha(Event ev) {
        if (txtSenha.getValue().equals("**********")) {
            txtSenha.setConstraint("");
            txtSenha.setText("");
            txtSenha.setConstraint("no empty");

            txtConfirmSenha.setConstraint("");
            txtConfirmSenha.setText("");
            txtConfirmSenha.setConstraint("no empty");
        }

    }

    public void onFocus$txtConfirmSenha(Event ev) {
        if (txtConfirmSenha.getValue().equals("**********")) {
            txtSenha.setConstraint("");
            txtSenha.setText("");
            txtSenha.setConstraint("no empty");

            txtConfirmSenha.setConstraint("");
            txtConfirmSenha.setText("");
            txtConfirmSenha.setConstraint("no empty");
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        txtCveEmpleado.setConstraint("no empty");
        txtCveEmpleado.getValue();
        txtCveEmpleado.setConstraint("");
        try {

            txtNombUsuario.setConstraint("");
            txtNombPaterno.setConstraint("");
            txtNombMaterno.setConstraint("");

            txtNombUsuario.setValue("");
            txtNombPaterno.setValue("");
            txtNombMaterno.setValue("");

            txtNombUsuario.setConstraint("no empty");
            txtNombPaterno.setConstraint("no empty");
            txtNombMaterno.setConstraint("no empty");

            List<Empleado> emp = empleadoService.pesquisaClave(txtCveEmpleado.getValue());
            txtCveUsuario.focus();

            if (emp.isEmpty()) {
                txtNombUsuario.setDisabled(false);
                txtNombPaterno.setDisabled(false);
                txtNombMaterno.setDisabled(false);

                Messagebox.show(
                        Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("editarUsuarioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {

                List<Usuario> listUsuario = usuarioService.buscarPorEmpleado(emp.get(0));

                if (listUsuario.isEmpty()) {

                    txtNombUsuario.setDisabled(true);
                    txtNombPaterno.setDisabled(true);
                    txtNombMaterno.setDisabled(true);

                    txtNombUsuario.setValue(emp.get(0).getNombEmpleado());
                    txtNombPaterno.setValue(emp.get(0).getNombPaterno());
                    txtNombMaterno.setValue(emp.get(0).getNombMaterno());

                    usuario.setNombusuario(emp.get(0).getNombEmpleado());
                    usuario.setNombpaterno(emp.get(0).getNombPaterno());
                    usuario.setNombmaterno(emp.get(0).getNombMaterno());

                    usuario.setEmpleado(emp.get(0));


                } else {
                    txtNombUsuario.setDisabled(false);
                    txtNombPaterno.setDisabled(false);
                    txtNombMaterno.setDisabled(false);
                    Messagebox.show(
                            Labels.getLabel("editarUsuarioController.MSG.existeEmpleado", new Object[]{txtCveEmpleado.getValue()}),
                            Labels.getLabel("editarUsuarioController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnSalvar(Event ev) {

        txtSenha.setConstraint("no empty");
        txtConfirmSenha.setConstraint("no empty");

        tabUsuario.setSelected(Boolean.TRUE);

        txtNombUsuario.getText();
        txtCveUsuario.getText();
        txtNombPaterno.getText();
        txtNombMaterno.getText();
        txtSenha.getText();
        txtConfirmSenha.getText();

        cmbPerfil.getValue();

        String senha = "";
        String confirmSenha = "";

        if (!txtSenha.getValue().equals("**********")) {
            senha = txtSenha.getText();
            confirmSenha = txtConfirmSenha.getText();
        }

        try {
            if (senha.equals(confirmSenha)) {
                usuario.setActivo(Boolean.TRUE);
                usuario.setFecmodif(Calendar.getInstance().getTime());
                usuario.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

                List<Usuario> lsUsuario = usuarioService.buscarPelaCveUsuario(usuario.getClaveUsuario());

                boolean podeSalvar = false;
                if (lsUsuario.isEmpty()) {
                    podeSalvar = true;
                } else {
                    for (Usuario u : lsUsuario) {
                        if (u.getUsuarioId().equals(usuario.getUsuarioId())) {
                            podeSalvar = true;
                        }
                    }
                }

                if (podeSalvar) {

                    if (!senha.trim().equals("")) {
                        MessageDigest md = MessageDigest.getInstance("MD5");
                        byte[] pass = md.digest(senha.getBytes());
                        senha = Base64.byteArrayToBase64(pass);

                        usuario.setSenha(senha);
                    }

                    Perfil perfil = (Perfil) cmbPerfil.getSelectedItem().getValue();
                    UsuarioPerfil up = new UsuarioPerfil();
                    up.setUsuario(usuario);
                    up.setPerfil(perfil);
                    up.setActivo(Boolean.TRUE);
                    up.setFecmodif(Calendar.getInstance().getTime());
                    up.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

                    if (usuario.getUsuarioId() != null) {
                        List<UsuarioPerfil> lsUsuarioPerfil = usuarioPerfilService.obtenerPorUsuario(usuario);
                        for (UsuarioPerfil up2 : lsUsuarioPerfil) {
                            usuarioPerfilService.borrar(up2);
                        }
                    }
                    List<UsuarioPerfil> lsUp = new ArrayList<UsuarioPerfil>();
                    lsUp.add(up);
                    usuario.setUsuarioPerfilList(lsUp);

                    if (!lsUsuarioUbicacion.isEmpty()) {
                        if (usuario.getUsuarioId() == null) {
                            usuario = usuarioService.suscribir(usuario);
                            if (usrAdmin) {
                                usuarioList.addItem(usuario);
                            }
                        } else {
                            usuario = usuarioService.actualizacion(usuario);
                            if (usrAdmin) {
                                usuarioList.updateItem(usuario);
                            }
                        }

                        for (UsuarioUbicacion uu : lsUsuarioUbicacion) {
                            if (uu.getUsuarioubicacionId() == null) {
                                uu.setUsuario(usuario);
                                usuarioUbicacionService.suscribir(uu);
                            }
                        }

                        Messagebox.show(
                                Labels.getLabel("editarUsuarioController.MSG.suscribirOK"),
                                Labels.getLabel("editarUsuarioController.window.title"),
                                Messagebox.OK, Messagebox.INFORMATION);

                        closeWindow();
                    } else {
                        tabUbicacion.setSelected(Boolean.TRUE);
                        Messagebox.show(
                                Labels.getLabel("editarUsuarioController.MSG.necessitaUbicacion"),
                                Labels.getLabel("editarUsuarioController.window.title"),
                                Messagebox.OK, Messagebox.EXCLAMATION);
                    }
                } else {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarUsuarioController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            } else {
                Messagebox.show(
                        Labels.getLabel("editarUsuarioController.MSG.configmSenha"),
                        Labels.getLabel("editarUsuarioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }
        } catch (Exception ex) {
            Clients.alert(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarUsuarioController.window.title"), Messagebox.ERROR);
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarUsuarioController.MSG.borrarPergunta"),
                    Labels.getLabel("editarUsuarioController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                usuarioService.borrar(usuario);

                Messagebox.show(
                        Labels.getLabel("editarUsuarioController.MSG.borrarOK"),
                        Labels.getLabel("editarUsuarioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                if (usrAdmin) {
                    usuarioList.removeItem(usuario);
                }

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnAdicionarUbicacion(Event ev) {
        Comboitem cbiParada = cmbParada.getSelectedItem();
        Comboitem cbiPuntoVenta = cmbPuntoVenta.getSelectedItem();

        if ((cbiParada != null) && (cbiPuntoVenta != null)) {
            Parada parada = (Parada) cbiParada.getValue();
            PuntoVenta puntoVenta = (PuntoVenta) cbiPuntoVenta.getValue();

            UsuarioUbicacion uu = new UsuarioUbicacion();
            uu.setActivo(Boolean.TRUE);
            uu.setFecmodif(Calendar.getInstance().getTime());
            uu.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            uu.setParada(parada);
            uu.setPuntoVenta(puntoVenta);
            uu.setUsuario(usuario);

            lsUsuarioUbicacion.add(uu);
            ubicacionList.setData(lsUsuarioUbicacion);

            enableAddUbicacion();
        }
    }

    public void onClick$btnRemoverUbicacion(Event ev) {
        UsuarioUbicacion uu = (UsuarioUbicacion) ubicacionList.getSelected();
        if (uu != null) {
            uu.setActivo(Boolean.FALSE);
            uu.setFecmodif(Calendar.getInstance().getTime());
            uu.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            lsUsuarioUbicacion.remove(uu);
            ubicacionList.setData(lsUsuarioUbicacion);

            if (uu.getUsuarioubicacionId() != null) {
                usuarioUbicacionService.borrar(uu);
            }
        }

        enableAddUbicacion();
    }
}
