/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.utilerias.render;

import com.rjconsultores.ventaboletos.entidad.CategoriaDescuento;
import com.rjconsultores.ventaboletos.entidad.CategoriaPeriodo;
import java.text.SimpleDateFormat;
import java.util.List;
import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;

/**
 *
 * @author Rafius
 */
public class RenderConfiguracionCategoriaDecuento implements ListitemRenderer {

    public void render(Listitem lstm, Object o) throws Exception {
        CategoriaDescuento categoria = (CategoriaDescuento) o;

        Listcell lc = new Listcell(categoria.getCategoria() != null ? categoria.getCategoria().getDesccategoria() : "0");
        lc.setParent(lstm);

        lc = new Listcell(categoria.getCantautorizada() != null ? categoria.getCantautorizada().toString() : "0");
        lc.setParent(lstm);

        lc = new Listcell(categoria.getDescuentoimporte() != null ? categoria.getDescuentoimporte().toString() : "0");
        lc.setParent(lstm);

        lc = new Listcell(categoria.getDescuentoporc() != null ? categoria.getDescuentoporc().toString() : "0");
        lc.setParent(lstm);

        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy HH:mm");
        String vigencia = "";
        List<CategoriaPeriodo> lsCategoriaPeriodo = categoria.getCategoriaPeriodoList();
        for (CategoriaPeriodo cp : lsCategoriaPeriodo) {
            if (cp.getActivo()) {
                if (cp.getFecinicio() != null) {
                    vigencia = vigencia + sdf.format(cp.getFecinicio());
                }

                vigencia = vigencia + " - ";

                if (cp.getFecfin() != null) {
                    vigencia = vigencia + sdf.format(cp.getFecfin());
                }

                vigencia = vigencia + "; ";
            }
        }
        lc = new Listcell(vigencia);
        lc.setParent(lstm);

        lstm.setAttribute("data", categoria);
    }
}
